
def fmask_to_bool(fmask, categories):
    """

    example:
        xx = dc.load(.., measurements=['fmask', ...])
        no_cloud = fmask_to_bool(xx.fmask, ('valid', 'snow', 'water'))

        xx.where(no_cloud).isel(time=0).nbar_red.plot.imshow()
    """
    import xarray as xr

    def _get_mask(names, flags):
        enum_to_value = {n: int(v)
                         for v, n in flags['fmask']['values'].items()}
        m = 0
        for n in names:
            m |= (1 << enum_to_value[n])
            return m

    m = _get_mask(categories, fmask.flags_definition)

    return xr.apply_ufunc(lambda x: ((1 << x) & m) > 0, fmask)
